diff -ruN gcc-15.1.0.orig/libstdc++-v3/libsupc++/new_opa.cc gcc-15.1.0/libstdc++-v3/libsupc++/new_opa.cc
--- gcc-15.1.0.orig/libstdc++-v3/libsupc++/new_opa.cc	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/libsupc++/new_opa.cc	2025-04-25 15:58:40.296620091 +0300
@@ -97,7 +97,10 @@
 #else // !HAVE__ALIGNED_MALLOC && !HAVE_POSIX_MEMALIGN && !HAVE_MEMALIGN
 // The C library doesn't provide any aligned allocation functions, define one.
 // This is a modified version of code from gcc/config/i386/gmm_malloc.h
-static inline void*
+#ifndef __MORPHOS__
+static
+#endif
+inline void*
 aligned_alloc (std::size_t al, std::size_t sz)
 {
   // We need extra bytes to store the original value returned by malloc.
diff -ruN gcc-15.1.0.orig/libstdc++-v3/src/c++11/locale_init.cc gcc-15.1.0/libstdc++-v3/src/c++11/locale_init.cc
--- gcc-15.1.0.orig/libstdc++-v3/src/c++11/locale_init.cc	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/src/c++11/locale_init.cc	2025-04-25 15:58:40.296620091 +0300
@@ -447,7 +447,11 @@
 #if _GLIBCXX_USE_DUAL_ABI
   // Facets that are instantiated for both the COW and SSO std::string ABIs.
   // The COW ABI version must come first, followed by its SSO twin.
+  #ifdef __MORPHOS__
+  const locale::id* locale::_S_twinned_facets[] = {
+  #else
   const locale::id* const locale::_S_twinned_facets[] = {
+  #endif
     &::_ZNSt8numpunctIcE2idE,
     &numpunct<char>::id,
     &::_ZNSt7collateIcE2idE,
diff -ruN gcc-15.1.0.orig/libstdc++-v3/src/c++17/ryu/f2s_intrinsics.h gcc-15.1.0/libstdc++-v3/src/c++17/ryu/f2s_intrinsics.h
--- gcc-15.1.0.orig/libstdc++-v3/src/c++17/ryu/f2s_intrinsics.h	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/src/c++17/ryu/f2s_intrinsics.h	2025-04-25 15:58:40.296620091 +0300
@@ -17,6 +17,11 @@
 #ifndef RYU_F2S_INTRINSICS_H
 #define RYU_F2S_INTRINSICS_H
 
+#ifndef UINT32_MAX
+/* This is fugly, but stdint.h has already been included without __STDC_LIMIT_MACROS - Piru */
+#define UINT32_MAX 4294967295U
+#endif
+
 // Defines RYU_32_BIT_PLATFORM if applicable.
 
 #if defined(RYU_FLOAT_FULL_TABLE)
diff -ruN gcc-15.1.0.orig/libstdc++-v3/src/filesystem/ops.cc gcc-15.1.0/libstdc++-v3/src/filesystem/ops.cc
--- gcc-15.1.0.orig/libstdc++-v3/src/filesystem/ops.cc	2025-04-25 11:18:05.000000000 +0300
+++ gcc-15.1.0/libstdc++-v3/src/filesystem/ops.cc	2025-04-25 15:58:40.296620091 +0300
@@ -127,11 +127,6 @@
 
 #ifdef _GLIBCXX_USE_REALPATH
   char_ptr buf{ nullptr };
-# if _XOPEN_VERSION < 700
-  // Not safe to call realpath(path, NULL)
-  using char_type = fs::path::value_type;
-  buf.reset( (char_type*)::malloc(PATH_MAX * sizeof(char_type)) );
-# endif
   if (char* rp = ::realpath(pa.c_str(), buf.get()))
     {
       if (buf == nullptr)
